=== modified file 'bzrlib/revisionspec.py'
--- bzrlib/revisionspec.py	2006-08-21 21:45:16 +0000
+++ bzrlib/revisionspec.py	2006-08-21 21:53:26 +0000
@@ -148,9 +148,9 @@
             # special case - the empty tree
             return info
         elif self.prefix:
-            raise NoSuchRevision(branch, self.prefix + str(self.spec))
+            raise errors.InvalidRevisionSpec(self.prefix + self.spec, branch)
         else:
-            raise NoSuchRevision(branch, str(self.spec))
+            raise errors.InvalidRevisionSpec(self.spec, branch)
 
     def in_history(self, branch):
         if branch:
@@ -251,9 +251,10 @@
 
     def _match_on(self, branch, revs):
         try:
-            return RevisionInfo(branch, revs.index(self.spec) + 1, self.spec)
+            revno = revs.index(self.spec) + 1
         except ValueError:
-            return RevisionInfo(branch, None, self.spec)
+            revno = None
+        return RevisionInfo(branch, revno, self.spec)
 
 SPEC_TYPES.append(RevisionSpec_revid)
 

=== modified file 'bzrlib/tests/test_revisionnamespaces.py'
--- bzrlib/tests/test_revisionnamespaces.py	2006-08-21 21:45:16 +0000
+++ bzrlib/tests/test_revisionnamespaces.py	2006-08-21 21:53:26 +0000
@@ -76,13 +76,13 @@
                           (1, 'a@r-0-1'))
         self.assertEquals(RevisionSpec('revid:a@r-0-1').in_history(b),
                           (1, 'a@r-0-1'))
-        self.assertRaises(errors.NoSuchRevision,
+        self.assertRaises(errors.InvalidRevisionSpec,
                           RevisionSpec('revid:a@r-0-0').in_history, b)
         self.assertRaises(TypeError, RevisionSpec, object)
 
         self.assertEquals(RevisionSpec('date:today').in_history(b),
                           (2, 'a@r-0-2'))
-        self.assertRaises(errors.NoSuchRevision,
+        self.assertRaises(errors.InvalidRevisionSpec,
                           RevisionSpec('date:tomorrow').in_history, b)
         self.assertEquals(RevisionSpec('date:yesterday').in_history(b),
                           (1, 'a@r-0-1'))

